package indexjob;
// Handles new indices coming from outside the cluster
// Here we are using the simba cluster as the central point of the index
import edu.sdsc.grid.io.GeneralFile;
import edu.sdsc.grid.io.srb.SRBFileSystem;
import edu.sdsc.grid.io.srb.SRBFile;
import edu.sdsc.grid.io.srb.SRBFileInputStream;
import edu.sdsc.grid.io.srb.SRBFileOutputStream;
import edu.sdsc.grid.io.srb.SRBException;
import edu.sdsc.grid.io.local.LocalFile;
import edu.sdsc.grid.io.srb.SRBRandomAccessFile;
import edu.sdsc.grid.io.srb.SRBAccount;

import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.index.IndexWriter;
import org.apache.lucene.index.Term;
import org.apache.lucene.index.TermEnum;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.FSDirectory;
import java.util.StringTokenizer;
import org.apache.lucene.store.SRBDirectory;

import java.net.*;
import java.io.*;
import java.util.Random;
import java.lang.Process;
import java.lang.Runtime;
import java.util.Vector;

public class IndexManager{

    private static  int IndexManagerPort = 9096;
    private static ServerSocket managerSocket;
    private static Socket indexholderSocket;
    private static SRBFileSystem srbFileSystem = null;
    private static SRBFile srbDir = null;
    private static SRBAccount srbAccount = null;

    public static void main(String [] args) throws Exception{

        String indextoget, indexonmachine, server, host , machine;

        //list of all servers available
        BufferedReader serverFile = new BufferedReader(new FileReader(new File("/home/nnakasho/apps/GriSAD/indexjob/allservers")));
        int totservers = Integer.parseInt(serverFile.readLine());
        String [] servers = new String[totservers];
        for(int i =0; i < totservers; i++){
            servers[i] = new StringTokenizer(serverFile.readLine(), ".").nextToken();
        }
        serverFile.close();
        managerSocket = new ServerSocket(IndexManagerPort);

        Random randy = new Random();
        //wait for notifications re new indices
        while(true){
            System.out.println("\nWaiting for index notifications ...\n");
            indexholderSocket  = managerSocket.accept(); //wait for results
            BufferedReader in = new BufferedReader(new InputStreamReader(indexholderSocket.getInputStream()));
            indextoget = in.readLine();
            indextoget= indextoget.trim();

            System.out.println("\ngot : "+ indextoget );
            if(indextoget.equals("synch")){ //for synchronising index on dizzy
                System.out.println("\nCopying index to dizzy ...\n");
                String ionsimba, iondizzy;
                writeMdasEnv("simba.cs.uct.ac.za");

                /*srbAccount.setDefaultStorageResource("dizzy");
                srbAccount.setHost("simba.cs.uct.ac.za");
                srbAccount.setPort(5544);
                srbFileSystem = new SRBFileSystem(srbAccount);
                srbFileSystem = handler.getSRBFileSystem();*/

                BufferedReader dizzyFile = new BufferedReader(new FileReader(new File("/home/nnakasho/apps/GriSAD/indexjob/dizzyservers")));
                int totdizzys = Integer.parseInt(dizzyFile.readLine());
                String [] dizzyservers = new String[totdizzys];
                for(int i =0; i < totdizzys; i++){
                    dizzyservers[i] = dizzyFile.readLine();

                }

                int i =0, j=0;Process p;BufferedReader in2, in3;String line;
                for(i =0; (i < totservers && j < totdizzys);i++){
                    ionsimba="_index_"+servers[i];
                    //SRBFile filetoget = new SRBFile(srbFileSystem, ionsimba);
                    //if(filetoget.exists()){
                        iondizzy="_index_"+dizzyservers[j];
                        //SRBFile filetoput = new SRBFile(srbFileSystem, iondizzy);
                        System.out.println("\nCopying >"+ionsimba +" to > "+iondizzy +" ...\n");
                        String cmd = "Scp -r -S dizzy /hpc/home/srbAdmin.ucthpc/"+ionsimba+" /hpc/home/srbAdmin.ucthpc/"+iondizzy;
                        p = Runtime.getRuntime().exec(cmd); 
                        in2= new BufferedReader(new InputStreamReader(p.getErrorStream()));
                        line= null;
                        while ((line = in2.readLine()) != null){
                        System.out.println(line);
                         System.out.println("\n**** ***" +cmd);
                        }
                        in3 = new BufferedReader(new InputStreamReader(p.getInputStream()));
                        line = null;
                        while ((line = in3.readLine()) != null){
                        System.out.println(line);
                        System.out.println("\n+++ +++" +cmd);
                        }
                        in3.close(); in2.close(); 
                         //filetoget.copyTo(filetoput);
                        j++;
                    //}
                }
                System.out.println("\n Operation complete !\n");
                if(totservers < i){ //merge indices 
                }
                writeMdasEnv("dizzy.lcc.uct.ac.za");

            }
            else{
                int i=0;
                SRBHandler handler =  new SRBHandler();
                srbAccount = handler.getSRBAccount();
                srbFileSystem = handler.getSRBFileSystem();
                //check which server has no index
                for(i =0; i < totservers;i++){
                    indexonmachine="_index_"+servers[i];
                    srbDir = new SRBFile(srbFileSystem, indexonmachine);
                    if(!srbDir.exists())
                        break;
                }
    
                if(i>=totservers){   // if all the servers have indices, then merge
                    server= servers[randy.nextInt(totservers)];
                    indexonmachine = "_index_"+server;
                    machine = new StringTokenizer(server, ".").nextToken();
                    host = machine+".cluster.aim";
                    srbAccount.setDefaultStorageResource(machine);
                    srbAccount.setHost(host);
                    srbFileSystem = new SRBFileSystem(srbAccount);

                    System.out.println("MERGING index > " + indextoget + " with > " + indexonmachine);
                    SRBDirectory theindexdir = new SRBDirectory(indexonmachine, machine, host);
                    IndexWriter writer = new IndexWriter(theindexdir, new StandardAnalyzer(), false);

                    SRBDirectory dirtoget = new SRBDirectory(indextoget, machine, host);
                    Directory [] thedirs = new Directory[]{dirtoget};
                    writer.addIndexes(thedirs);
                    writer.close();
                    deleteAllFiles(new SRBFile(srbFileSystem, indextoget));

                    System.out.println("Done > " + indextoget + "=> "+ indexonmachine);
                }
                else{
                    indexonmachine = "_index_"+servers[i];
                    machine = new StringTokenizer(servers[i], ".").nextToken();
                    host = machine+".cluster.aim";
                    srbAccount.setDefaultStorageResource(machine.trim());
                    srbAccount.setHost(host.trim());
                    srbFileSystem = new SRBFileSystem(srbAccount);
    
                    System.out.println("COPYING index > " + indextoget + " to > "+ indexonmachine);
                    SRBFile filetoget = new SRBFile(srbFileSystem, indextoget);
                    SRBFile filetoput = new SRBFile(srbFileSystem,indexonmachine);
                    try{
                        filetoget.copyTo(filetoput);
                        deleteAllFiles(filetoget);
                    }
                    catch(Exception e){
                        System.out.println("Error renaming file: " +indextoget + " to " + indexonmachine);
                        e.printStackTrace();
                    }
                    System.out.println("Done > " + indextoget + "=> "+ indexonmachine);

                }
                srbFileSystem.close();
            }
            indexholderSocket.close();
            in.close();
        }
    }
    protected void finalize(){
    //Clean up 
        try{
            managerSocket.close();
            indexholderSocket.close();

        } catch (Exception e) {
            System.out.println("Could not close.");
            System.exit(-1);
        }
    }

    /** Delete all files and directory */
    public static boolean deleteAllFiles(SRBFile dir) { 
        if(!dir.exists()) 
            return true; 

        boolean res = true; 
        if(dir.isDirectory()) {
            GeneralFile[] files = dir.listFiles();
            for(int i = 0; i < files.length; i++) 
                res &= deleteAllFiles((SRBFile)files[i]);
            res = dir.delete();//Delete dir itself
        } else 
            res = dir.delete(); 
        return res;
    }
    public static void writeMdasEnv(String host)throws Exception{
        String content = "mdasCollectionName '/hpc/home/srbAdmin.ucthpc'\nmdasCollectionHome '/hpc/home/srbAdmin.ucthpc'\nmdasDomainName 'ucthpc'\nmdasDomainHome 'ucthpc'\nsrbUser 'srbAdmin'\nsrbHost '" +host + "'\n#srbPort '5544'\ndefaultResource 'dizzy'\nAUTH_SCHEME 'ENCRYPT1'";
        PrintWriter out2 = new PrintWriter(new BufferedWriter(new FileWriter("/home/nnakasho/.srb/.MdasEnv", false)));
        out2.println(content);
        out2.close();
    }

}