//package org.apache.lucene.demo;

/**
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import edu.sdsc.grid.io.GeneralFile;
import edu.sdsc.grid.io.srb.SRBAccount;
import edu.sdsc.grid.io.srb.SRBFileSystem;
import edu.sdsc.grid.io.srb.SRBFile;
import edu.sdsc.grid.io.srb.SRBFileInputStream;
import edu.sdsc.grid.io.srb.SRBFileOutputStream;
import edu.sdsc.grid.io.srb.SRBException;
import edu.sdsc.grid.io.local.LocalFile;

import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.index.IndexWriter;
import org.apache.lucene.index.Term;
import org.apache.lucene.index.TermEnum;
import org.apache.lucene.store.SRBDirectory;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.FSDirectory;

import java.io.File;
import java.util.Date;
import java.util.Arrays;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.FileReader;
import java.util.StringTokenizer;
import java.net.Socket;
import java.net.ServerSocket;

import java.lang.Process;
import java.lang.Runtime;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Random;

/** Indexer for HTML files stored on SRB. */
public class Indexer {
  public Indexer() {}

  private static boolean deleting = false;	  // true during deletion pass
  private static IndexReader reader;		  // existing index
  private static IndexWriter writer;		  // new index being built
  private static TermEnum uidIter;		  // document id iterator
  static SRBAccount srbAccount = null;
  static SRBFileSystem srbFileSystem = null;
  static SRBFile srbFile = null;
  static SRBFile srbDir = null;
  static SRBFileInputStream srbFileIn = null;  
  static GeneralFile[] SRBfiles;
  static LocalFile corpusDirFile;
  static File INDEX_DIR;
  static String SRBdirName = " ";
  static boolean merge = false;
  static SRBFile indexonmachine = null;
  static boolean onSimba= false;
  static boolean onDizzy= false;
  static Directory tempdir = null;
  static String  queryserver="none";
  static int totaltxt=0;
  static int totalindexed = 0;

  /** Indexer for HTML files.*/
  public static void start(String[] argv) throws Exception {
      String index = "_index_";
      boolean create = false;
      File root = null;
      String SRBCorpusDir = " ";
      int allocatorport = 9097;
      //LocalFile Env = new LocalFile(".MdasEnv");
      //LocalFile Auth = new LocalFile(".MdasAuth"); 

      //attempt to connect ****
      // and keep trying until connection is established

      //SRBHandler handler = new SRBHandler(Env,Auth);
//       while(handler ==null){
//         try{
//             handler = new SRBHandler(Env,Auth);
//         }
//         catch(Exception e){Thread.sleep(2000);}
// 
//       }

      //srbAccount = handler.getSRBAccount();

      String host = "null";
      String usage = "IndexHTML [-create] [-index <index>] <root_directory>";

      System.out.println("ARGV: "+ argv.length);
      if (argv.length == 0) {
        System.err.println("Usage: " + usage);
        return;
      }

      for (int i = 0; i < argv.length; i++) {
        if (argv[i].equals("-index")) {		  // parse -index option
          index = argv[++i];
        } else if (argv[i].equals("-create")) {	  // parse -create option
          create = true;
        }else if(argv[i].equals("-qserver")){
           queryserver=argv[++i];
        }else if(argv[i].equals("-host")){
           host=argv[++i];
        }else if (i != argv.length-1) {
          System.err.println("Usage: " + usage);
          return;
        } else
          SRBCorpusDir = argv[i];
          //root = new File(srbFileSystem, argv[i]);
      }

      /* Check if index already exists on this machine, if not then create a new one else merge indices*/
     long s=0, e=0;float se=0;
     s=new Date().getTime();
     String localvault = new StringTokenizer(host, ".").nextToken();
//       System.out.println("Local vault: "+ localvault);
//       if( ((java.net.InetAddress.getLocalHost().getHostName()).indexOf(".cluster.aim")) >=0){
//         onSimba=true;
//         StringTokenizer st = new StringTokenizer(SRBCorpusDir,"/");
//         SRBCorpusDir = st.nextToken() + "cluster_"+ localvault+"/"+st.nextToken(); //user the data on the cluster
// 
//       }
//       else if(((java.net.InetAddress.getLocalHost().getHostName()).indexOf("sarabi") >=0)){
//         onSimba= false;
//         System.out.println("Simba");
//       }

//       if(onSimba){
//         srbAccount.setHost(java.net.InetAddress.getLocalHost().getHostName());
//         srbAccount.setDefaultStorageResource(localvault);
//       }
//       else{
//         srbAccount.setHost("sarabi.cs.uct.ac.za");
//         srbAccount.setDefaultStorageResource("sarabi");
//       }
      //srbAccount.setHost(java.net.InetAddress.getLocalHost().getHostName());
      //srbAccount.setDefaultStorageResource(localvault);
      //srbFileSystem = new SRBFileSystem(srbAccount);

      //StringTokenizer st = new StringTokenizer(SRBCorpusDir,"/");
      //st.nextToken();
      String tempname= "index"+"_"+localvault;

      Random randy = new Random();
      SRBdirName = Integer.toString(getRandom(randy,10000))+tempname+".zip";
      //SRBdirName = Integer.toString(getRandom(randy,10000))+tempname+"_"+st.nextToken(); //compressed index
      INDEX_DIR = new File(tempname);
      merge = false;

//         srbDir = new SRBFile(srbFileSystem, SRBCorpusDir);
//         corpusDirFile = new LocalFile(SRBCorpusDir);
//         try {
//             System.out.println("Copying files from SRB...\r"+SRBCorpusDir);
//             long copyStart      = new Date().getTime();
//             srbDir.copyTo(corpusDirFile, true, true);
//             long  copyEnd  = new Date().getTime();
//             float copySecs = (float) (copyEnd - copyStart) / 1000; 
//             File zipped = corpusDirFile.getFile();
//             //we have a a tar file untar it and proceed
//             Unzip unzip = new Unzip();
//             String nameofdir = new StringTokenizer(zipped.getName(),".").nextToken();
//             nameofdir = unzip.unzip(SRBCorpusDir);
//             root = new File(nameofdir);
// 
//             System.out.println("Finished copying files from SRB in "+ copySecs + " secs");
//         } catch (NullPointerException e) {
//             throw new FileNotFoundException("Cannot open: " + 
//                 srbDir.getAbsolutePath());
//         }

        BufferedReader lavg = new BufferedReader(new FileReader(new File("/proc/loadavg")));
        String avg= lavg.readLine();
        System.out.println("Load average BEFORE Indexing: "+ avg);
        lavg.close();
        root = new File(SRBCorpusDir);

        System.out.println("begining to index");
        Date start = new Date();
        tempdir = FSDirectory.getDirectory(INDEX_DIR);

        if (!create) {			  // delete stale docs
            System.out.println("NOT creating");
            deleting = true;
            indexDocs(root,tempdir , create);
        }
        System.out.println("done indexing");
        writer = new IndexWriter(tempdir, new StandardAnalyzer(), create);
        writer.setMaxFieldLength(1000000);
        writer.setMergeFactor(10000);
        indexDocs(root,tempdir, create);		  // add new docs

        System.out.println("Optimizing index...");
        writer.optimize();
        writer.close();

        BufferedReader lavg2 = new BufferedReader(new FileReader(new File("/proc/loadavg")));
        avg = lavg2.readLine();
        System.out.println("Load average AFTER Indexing: "+ avg);
        lavg2.close();

        Date end = new Date();
        System.out.print(end.getTime() - start.getTime());
        System.out.println(" total milliseconds");

//       System.out.println("Local vault: "+ localvault);
        //compress the index here
        Zip compress = new Zip();
        compress.zipDir(SRBdirName,tempname);
        File filetowrite= new File(SRBdirName);
        System.out.println("\n****Total indexed "+totalindexed);
// 	 if(!merge){
// 	   System.out.println("copying index to SRB");
// 	   writeToSRB(filetowrite,2);
// 	 }
//         
      /* if(onSimba){//write the index to disk
            System.out.println("copying index to SRB");
	    writeToSRB(filetowrite,2);

            deleteAllFiles(new File(tempname));
            filetowrite.delete();
            //ask for a new chunk
            String request = "newrequest:"+ host;
            Socket allocator = new Socket("sarabi.cs.uct.ac.za", allocatorport);
            PrintWriter socketout = new PrintWriter(allocator.getOutputStream(), true);
            socketout.println(request);
            socketout.flush();
            socketout.close();
            allocator.close();*/
//        }else{
            e=new Date().getTime();
            se = (float)(e-s)/1000;
            System.out.println("Indexing: Rest of thing"+ se);
            //inform srb of new chunk completed
            String request = "chunkcompleted:"+ host+":"+Float.toString(se)+":"+filetowrite.getAbsolutePath();
            Socket allocator = new Socket("sarabi.cs.uct.ac.za", allocatorport);
            PrintWriter socketout = new PrintWriter(allocator.getOutputStream(), true);
            socketout.println(request);
            socketout.flush();
            socketout.close();
            allocator.close();

            
        //}
  }

  /* Walk directory hierarchy in uid order, while keeping uid iterator from
  /* existing index in sync.  Mismatches indicate one of: (a) old documents to
  /* be deleted; (b) unchanged documents, to be left alone; or (c) new
  /* documents, to be indexed.
   */

  private static void indexDocs(File file, Directory indexdir, boolean create)
       throws Exception {
    if (!create) {				  // incrementally update

      reader = IndexReader.open(indexdir);		  // open existing index
      uidIter = reader.terms(new Term("uid", "")); // init uid iterator

      indexDocs(file);

      if (deleting) {				  // delete rest of stale docs
        while (uidIter.term() != null && uidIter.term().field() == "uid") {
          System.out.println("deleting " +
              HTMLDocument.uid2url(uidIter.term().text()));
          reader.deleteDocuments(uidIter.term());
          uidIter.next();
        }
        deleting = false;
      }

      uidIter.close();				  // close uid iterator
      reader.close();				  // close existing index

    } else					  // don't have exisiting
      indexDocs(file);
  }

    private static void writeToSRB(File filetowrite, int numReps) {

    try {
      LocalFile Env = new LocalFile(".MdasEnv");
      LocalFile Auth = new LocalFile(".MdasAuth"); 
      SRBHandler md = new SRBHandler(Env, Auth);
      //SRBHandler md = new SRBHandler();
      String localvault = new StringTokenizer(java.net.InetAddress.getLocalHost().getHostName(),".").nextToken();
      srbAccount = md.getSRBAccount();

      if(onSimba){
        srbAccount.setHost(java.net.InetAddress.getLocalHost().getHostName());
        srbAccount.setDefaultStorageResource(localvault);
      }
      else if(onDizzy){
        srbAccount.setHost("dizzy.lcc.uct.ac.za");
        srbAccount.setDefaultStorageResource("dizzy");
      }
     else{
        srbAccount.setHost("sarabi.cs.uct.ac.za");
        srbAccount.setDefaultStorageResource("machine2");
     }
     SRBFileSystem srbFS = new SRBFileSystem(srbAccount);

      /*if (fromSRB) {
          SRBdirName = INDEX_DIR.getName() + 
              "_xd";/* + Integer.toString(maxToIndex) + 
              "_r" + Integer.toString(numReps);                
      /*} else {
          SRBdirName = INDEX_DIR.getName() + 
              "_d" + Integer.toString(maxToIndex) + 
              "_r" + Integer.toString(numReps);                
      }*/

      LocalFile localIndex = new LocalFile(filetowrite);
      System.out.println("\nlocal name: "+ INDEX_DIR.getName());
      localIndex.copyTo(new SRBFile(srbFS, SRBdirName));
      System.out.println("\nremote name: "+ SRBdirName);


    } catch (IOException e) {
        e.printStackTrace();
    }

  }
  private static void indexDocs(File file) throws Exception {
    totalindexed++;
    String name = file.getName();
    int dotIndex = name.indexOf(".");
    String ext ="";
    if ((dotIndex > 0) && (dotIndex < name.length())){
        ext = name.substring(dotIndex + 1, name.length());
    }
    //System.out.println("name:	"+ name+ "extention: "+ext);

    if (file.isDirectory()) {			  // if a directory
      String[] files = file.list();		  // list its files
      Arrays.sort(files);			  // sort the files
      for (int i = 0; i < files.length; i++)	  // recursively index them
        indexDocs(new File(file, files[i]));

    } else if ((file.getPath().indexOf(".htm") >0) ||
	   (file.getPath().indexOf(".php") >0) ||
      ext.equalsIgnoreCase("htm") || // index .htm, 
      ext.equalsIgnoreCase("html") || //.html files
      ext.equalsIgnoreCase("php")) { // index .php files

        try{					  // creating a new index
            Document doc = HTMLDocument.Document(file);
           // System.out.println("adding HTML " + doc.get("path"));
            writer.addDocument(doc);		  // add docs unconditionally
        }catch(Exception e){
            System.out.println("Could not add doc");
             //throw new FileNotFoundException("Cannot add document");
        }
    }
    else if(ext.equalsIgnoreCase("pdf")){  //index pdf files
	 	  try{
        Document doc = PDFDocument.Document(file);
        //System.out.println("adding PDF " + doc.get("path"));
        writer.addDocument(doc);
		  }catch(Exception e){System.out.println("An error for PDF");e.printStackTrace();}
    }
    else if(ext.equalsIgnoreCase("doc")){
        try{
		  Document doc = WordDocument.Document(file);
       // System.out.println("adding Word " + doc.get("path"));
        writer.addDocument(doc);
		  }catch(Exception e){System.out.println("An error for Word");e.printStackTrace();}
    }
    else if(ext.equalsIgnoreCase("txt")){

        totaltxt++;

    }

   }

    /** Delete all files and directory */
    public static boolean deleteAllFiles(SRBFile dir) { 
        if(!dir.exists()) 
            return true; 

        boolean res = true; 
        if(dir.isDirectory()) {
            GeneralFile[] files = dir.listFiles();
            for(int i = 0; i < files.length; i++) 
                res &= deleteAllFiles((SRBFile)files[i]);
            res = dir.delete();//Delete dir itself
        } else 
            res = dir.delete(); 
        return res;
    }
    public static boolean deleteAllFiles(File dir) { 
        if(!dir.exists()) 
            return true; 

        boolean res = true; 
        if(dir.isDirectory()) {
            File[] files = dir.listFiles();
            for(int i = 0; i < files.length; i++) 
                res &= deleteAllFiles(files[i]);
            res = dir.delete();//Delete dir itself
        } else 
            res = dir.delete(); 
        return res;
    }

    /**
    * Returns a random number
    *
    * @param max The maximum number to be returned by this method
    */
    public static int getRandom(Random randy, int max){
        return Math.abs(randy.nextInt(max));
    }
}
