//package indexjob;
 
import java.net.Socket;
import java.net.ServerSocket;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.net.InetAddress;
import java.io.FileReader;
import java.io.File;
import java.util.StringTokenizer;
import java.util.Date;

/**
* Requets data chunks for indexing from the DataAllocator
* @author ndapandula nakashole
**/
public class IndexerNode{

    public static void main(String [] args) throws Exception{
        int nodeport = 9017;
        int allocatorport = 9097;
        ServerSocket server;
        Socket client;
        String line;PrintWriter socketout=null;BufferedReader in;
        boolean newcycle, endofcycle = false;
        int numtimes = 1;
        if(args.length < 0){
            System.out.println("No arguments specified! using defaults ...");
            Integer.parseInt(args[0]);
        }
  
        String host = InetAddress.getLocalHost().getHostName();
        String request = "";
        String hostname = "";
        StringTokenizer st = new StringTokenizer(host, ".");
        if(st.countTokens() < 2)
		host+=".cs.uct.ac.za";
        hostname =st.nextToken();


        request = "chunkrequest:"+ host;

        Socket allocator = null;
		  
        newcycle = true;
        long start=0, end=0;float secs=0;
        server = new ServerSocket(nodeport);

        //Sunday 26th Extract chunk here ...  and then 
        // delete the .zip file
        Unzip unzip = new Unzip();
        start = new Date().getTime();
        String nameofdir = unzip.unzip("1.zip");
        end = new Date().getTime();
        secs = (float) (end -start)/1000;
        System.out.println("Time to unzip: "+ secs);

        //for(int j=0; j < numtimes;j++){
        while(true){

            boolean connected= false;
            while(!connected){
                try{
                    allocator = new Socket("sarabi.cs.uct.ac.za", allocatorport);
                    socketout = new PrintWriter(allocator.getOutputStream(), true);
                    System.out.println("\tNew cycle!");
                    System.out.println("Sending request");
                    socketout.println(request);
                    socketout.flush();
                    connected = true;
                }catch(Exception e){System.out.println("no one listening: ");
                    Thread.sleep(40000);//wait for the server to get ready;
                }
            }

            while(!endofcycle){ //wait for notifications
                System.out.println("Waiting for notifications ...");
                client = server.accept();
                in = new BufferedReader(new InputStreamReader(client.getInputStream()));
                line = in.readLine();
                System.out.println("Received: "+line);

                if(line.equals("3")){ //no more chunks
                    System.out.println("\tEnd of cycle!");
                    endofcycle = true;
                }else if(line.startsWith("4")){
                    System.out.println("\tIndex copied to server");

                    st = new StringTokenizer(line, ":");
                    st.nextToken(); //discard 4

                    //remove index:
                    String index = "index"+"_"+hostname;
                    deleteAllFiles(new File(index));
                    new File(st.nextToken()).delete();
                    //ask for a new chunk
                    request = "newrequest:"+ host;
                    allocator = new Socket("sarabi.cs.uct.ac.za", allocatorport);
                    socketout = new PrintWriter(allocator.getOutputStream(), true);
                    socketout.println(request);
                    socketout.flush();
                    socketout.close();
                    allocator.close();
                }
                else{
                    System.out.println("\tdoing a job");
                    Indexer indexer = new Indexer();
                    String [] arguments = new String[8];
                    st = new StringTokenizer(line, ":");
                    String tdir= st.nextToken();
                    String dir= st.nextToken();
                    String qserver=st.nextToken();

                    arguments[0] = "-create";
                    arguments[1] = "-index";
                    arguments[2]= "_index_";
                    arguments[3]= "-qserver";
                    arguments[4]= qserver;
                    arguments[5]= "-host";
                    arguments[6]= host;
                    //arguments[7] = tdir+"/"+dir;
                    arguments[7] = nameofdir;
                    start = new Date().getTime();
                    indexer.start(arguments);
                    end = new Date().getTime();
                    secs = (float) (end -start)/1000;
                    System.out.println("\n\nTime to index chunk: "+ secs);
                }
            } //end of while..
            endofcycle = false;
            Thread.sleep(40000);//wait for the server to get ready;
	    socketout.close();
	    allocator.close();
	}
/*
	socketout.close();
	allocator.close();*/
    }

    public static boolean deleteAllFiles(File dir) { 
        if(!dir.exists()) 
            return true; 

        boolean res = true; 
        if(dir.isDirectory()) {
            File[] files = dir.listFiles();
            for(int i = 0; i < files.length; i++) 
                res &= deleteAllFiles(files[i]);
            res = dir.delete();//Delete dir itself
        } else 
            res = dir.delete(); 
        return res;
    }


}