package indexjob;

import java.io.*;
import java.lang.Process;
import java.lang.Runtime;
public class StartWorkers{

    // start query programs on the known query servers
    public static void main(String [] args)throws Exception
    {

        BufferedReader serverFile = new BufferedReader(new FileReader(new File("/home/nnakasho/apps/GriSAD/indexjob/workers")));
        int totservers = Integer.parseInt(serverFile.readLine());
        String [] servers = new String[totservers];
        for(int i =0; i < totservers; i++){
            servers[i] = serverFile.readLine();
        }
        serverFile.close();
        writeMdasEnv("sarabi.cs.uct.ac.za");

	PrintWriter submitfile = new PrintWriter (new BufferedWriter (new FileWriter ("worker.submit", false))); //false for do not append
	String description = "Universe = java\nExecutable = /home/nnakasho/apps/GriSAD/indexjob/IndexerNode.class\nLog = worker.log.$(Cluster)\nOutput = workerjob.out.$(Cluster).$(Process)\nError = "+ "workerjob.error.$(Cluster)\nRequirements = machine =!= \"simba.cs.uct.ac.za\" \nShould_transfer_files = YES\nWhenToTransferOutput = ON_EXIT\ntransfer_input_files = /home/nnakasho/.srb/.MdasEnv,/home/nnakasho/.srb/.MdasAuth\njar_files = "+"/home/nnakasho/apps/lib/jargon_v1.4.20.jar,/home/nnakasho/apps/lib/lucene-core-2.1.0.jar,"+"/home/nnakasho/apps/GriSAD/indexjob/requiredfiles/requiredfiles.jar,/home/nnakasho/apps/lib/jargon_v1.4.20.jar,/home/nnakasho/apps/lib/fontbox.jar,/home/nnakasho/apps/lib/PDFBox.jar,/home/nnakasho/apps/lib/tm-extractors.jar,/home/nnakasho/SRB/SRB3_4_2/matrix/lib/activation.jar,/home/nnakasho/apps/lib/tar.jar,/home/nnakasho/apps/lib/bcprov-jdk15-138.jar,/home/nnakasho/apps/lib/bcmail-jdk15-138.jar\nnotification = never\nowner = \"nnakasho\"\n";

        for(int i =0; i <servers.length; i++){
                String arg = "Arguments = IndexerNode 1";
                arg+="\nRequirements = machine == \""+servers[i]+"\"";
                description+= (arg+"\nQueue\n\n");
                System.out.println("Server: "+servers[i]);
	}
	submitfile.println (description);
	submitfile.close();

        String cmd = "condor_submit worker.submit";
        Process p = Runtime.getRuntime().exec(cmd); //run the splitter program*/
    }
    public static void writeMdasEnv(String host)throws Exception{
        String content = "mdasCollectionName '/hpc/home/srbAdmin.ucthpc'\nmdasCollectionHome '/hpc/home/srbAdmin.ucthpc'\nmdasDomainName 'ucthpc'\nmdasDomainHome 'ucthpc'\nsrbUser 'srbAdmin'\nsrbHost '" +host + "'\n#srbPort '5544'\ndefaultResource 'machine1'\nAUTH_SCHEME 'ENCRYPT1'";
        PrintWriter out2 = new PrintWriter(new BufferedWriter(new FileWriter("/home/nnakasho/.srb/.MdasEnv", false)));
        out2.println(content);
        out2.close();
    }

}