 
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

public class Zip
{
    public Zip(){
    }
    public static void zipDir(String zipFileName, String dir)
    {
        File dirObj = new File(dir);
        if(!dirObj.isDirectory())
        {
            System.err.println(dir + " is not a directory");
            System.exit(1);
        }

        try
        {
            ZipOutputStream out = new ZipOutputStream(new FileOutputStream(zipFileName));

            //System.out.println("Creating : " + zipFileName);

            addDir(dirObj, out);
            // Complete the ZIP file
            out.close();
        }
        catch (IOException e)
        {
            e.printStackTrace();
            System.exit(1);
        }

    }

    private static void addDir(File dirObj, ZipOutputStream out) throws IOException
    {
        File[] files = dirObj.listFiles();
        byte[] tmpBuf = new byte[1024];

        for (int i=0; i<files.length; i++)
        {
            if(files[i].isDirectory())
            {
                addDir(files[i], out);
                continue;
            }
            FileInputStream in;
            try{
                in = new FileInputStream(files[i].getAbsolutePath());
                //System.out.println(" Adding: " + files[i].getPath());

                out.putNextEntry(new ZipEntry(files[i].getPath()));

                // Transfer from the file to the ZIP file
                int len;
                while((len = in.read(tmpBuf)) > 0)
                {
                    out.write(tmpBuf, 0, len);
                }
                // Complete the entry
                out.closeEntry();
                in.close();

            }catch(Exception e){
                //if it doesnt work leave it
            }

        }
    }

}
