package queryjob;
import java.util.Hashtable;
import java.util.Vector;
import java.lang.Math;
import java.io.*;
import java.net.*;
import java.util.Date;
import java.util.StringTokenizer;

public class QueryImpl{

    public static Hashtable ht = new Hashtable();
    public String acceptQuery(String query,String [] CODclaims, int queryID) {

        String [] thequeries = new String[1];
        thequeries[0] = query;String r ="";
        String ut = ":Query: "+query + "\tQID:"+queryID+"\n";
        System.out.println(new Date().toString() +":Query: "+query + "\tQID:"+queryID);
        try{
            ServerSocket server = new ServerSocket(0, 1000);
            int port = server.getLocalPort(); //any free port to wait for query results for this query

            BufferedReader serverFile = new BufferedReader(new FileReader(new File("/home/nnakasho/apps/GriSAD/queryjob/servers")));
            int totservers = Integer.parseInt(serverFile.readLine());
            String [] servers = new String[totservers];
            for(int i =0; i < totservers; i++){
                servers[i] = serverFile.readLine();
            }
            serverFile.close();

            int queryPort = 9095;
            //System.out.println("Sending to workers \tQID:"+queryID);
            //send query
            for(int j = 0; j < totservers; j++){
                Socket socket = new Socket(servers[j], queryPort);
                PrintWriter socketout = new PrintWriter(socket.getOutputStream(), true);
                String aquery= query+":"+queryID+":"+totservers+":"+port;
                socketout.println(aquery);
                socket.close();
                socketout.close();
            }
            System.out.println("Server port: "+port);

            Date start = new Date();
            StringTokenizer st;
            String item, detail, score, rqid,length; 
            Socket client = null;
            Vector received = new Vector();
            Vector coll_resultlength = new Vector();
            int totallength = 0;
            double avgscore=0.0, totalscore=0.0, K = 600.0;

            //get results from all query nodes
            while(received.size() != totservers){
                client = server.accept(); //wait for results
                BufferedReader in = new BufferedReader(new InputStreamReader(client.getInputStream()));
                String line = null;
                String all="";
                Date end = new Date(); 
                long elapsed =  end.getTime() - start.getTime();
                double time = elapsed/1000.0;

                while((line = in.readLine()) !=null){
                    all+=line;
                    //ut+="\t"+line+"\n";
                }
                st = new StringTokenizer(all,":");

                rqid = st.nextToken();      //queryid
                length = st.nextToken();    //result lengths
                item = st.nextToken()+":"+st.nextToken();
                while(st.hasMoreTokens()){ //get result:score pairs
                    item += ":"+st.nextToken()+":"+st.nextToken();
                }
                System.out.println("\tTHE Line: "+ item);
                received.addElement(item);
                coll_resultlength.addElement(new Integer(Integer.parseInt(length)));
            }

            //Rerank
            System.out.println("Size: "+ received.size());
            Vector details= new Vector(); 
            Vector scores = new Vector();
            Vector coll_scores = new Vector();
            Vector coll_weights = new Vector();

            for(int i=0;i< coll_resultlength.size();i++){
                totallength+= (Integer)coll_resultlength.elementAt(i);
            }

            //get scores
            for(int i=0;i< coll_resultlength.size();i++){
                double scorei = Math.log(1 + (( ((Integer)coll_resultlength.elementAt(i)).intValue() *K)/
                                 (double)totallength));
                 System.out.println("Score: "+ i + " "+scorei);
                coll_scores.addElement(scorei);
                totalscore+=scorei;
            }
            avgscore = totalscore/(double)totservers;
            System.out.println("AVG score: "+avgscore);

            //compute weights
            for(int i=0;i< coll_resultlength.size();i++){
                double wi = 1+ ( ((Double)coll_scores.elementAt(i)).doubleValue() -avgscore)/avgscore;
                coll_weights.addElement(wi);
                System.out.println("Weight: "+ i + " "+wi);
            }


            for(int i =0; i < received.size();i++){
                item = (String)received.elementAt(i);
                double wi = ((Double)coll_weights.elementAt(i)).doubleValue();
                if(!item.equals("null:0")){
                    //out.println();
                    st = new StringTokenizer(item,":");
                    while(st.hasMoreTokens()){
                        detail=st.nextToken();
                        score = st.nextToken();
                        details.addElement(detail);
                        scores.addElement(new Float(Double.parseDouble(score) * wi));

                        /* Implementation of re-ranking 
                         Before we add scores we boast them with the collection weight.
                         we go through all results
                        */
                    }
                }
            }
            System.out.println("done");
            Vector sorted = bubbleSort(details, scores, scores.size());
            //String ans = "";
             System.out.println("SORTED Size :"+ sorted.size());
            int end = Math.min(sorted.size(), 10); 
            for(int j = 0; j< end; j++){
                ut+= (j+1)+"."+(String)sorted.elementAt(j)+"\n";
            }
            if(sorted.size() ==0){
                ut= "nada";
            }

            ut+="\n";
            //ut+= "\n\tTotal time waiting for results from worker nodes: \n";// +time+ " seconds\n";
            //ut+="\t++Results++\n";
            //System.out.println("Done \tQID:"+queryID);
            server.close();
            client.close();
        }
        catch(Exception e) {
            try{
            PrintWriter out2 = new PrintWriter(new BufferedWriter(new FileWriter("/home/nnakasho/apps/GriSAD/queryjob/acceptquery_error.txt", true)));
            out2.println(e.getMessage());
            e.printStackTrace(out2);
            out2.close();
            ut+="\tError sending query\n";}catch(Exception be){}
        }
       
        return ut;
    }

    public void  mergeResults(int QueryID, String response, int numqueryservers, int port)throws Exception {

    }

    public String acceptQueries(String[] query) { // this method should be such that it accepts 
        //add stuff here that calls condor to create a job submit description file and submits the files to condor
        String s = "This is the query: "; 
        for(int i = 0; i < query.length; i++){
            s+=query[i] + " ";
        }
        return s;
    }

    //wait for results

    //This is one way of sorting a Vector whereby only every second item is considered for sorting, the rest is side info
    static Vector bubbleSort (Vector details, Vector scores, int arraysize)
    {
	boolean done = false;
	Vector kk = new Vector ();
	String [] arrdetail = new String [arraysize];
        float [] arrscore = new float [arraysize];
	for (int g = 0 ; g < arraysize ; g++){
            arrdetail[g] = (String) details.elementAt(g);
            arrscore[g] = ((Float)scores.elementAt(g)).floatValue();
	}

	for (int iter = arraysize ; iter > 0 && !done ; iter--)
	{
	    done = true;
	    // Sort 
	    for (int index = 1 ; index < iter ; index++)
	    {
		float ind1 = arrscore [index - 1];
	        float ind2 = arrscore [index];
		if (ind1 < ind2)
		{
		    swapf (arrscore, index - 1, index);
		    swaps (arrdetail,index - 1, index);
		    done = false;
		}
	    }
	}

	for (int g = 0 ; g < arraysize ; g++)
	{

	    //String in = new String (arrscore[g]);
           String h = arrdetail[g]; //+" " + (new Float (arrscore[g])).toString();
	    kk.addElement (h);

	}
	return kk;

    }

     // swap two elements of an array
    static  private void swapf (float [] array, int i, int j)
    {

	float  temp = array [i];
	array [i] = array [j];
	array [j] = temp;

    }
         // swap two elements of an array
    static private void swaps (String [] array, int i, int j)
    {
	String temp = array [i];
	array [i] = array [j];
	array [j] = temp;

    }
}