
import edu.sdsc.grid.io.GeneralFile;
import edu.sdsc.grid.io.srb.SRBFileSystem;
import edu.sdsc.grid.io.srb.SRBFile;
import edu.sdsc.grid.io.srb.SRBFileInputStream;
import edu.sdsc.grid.io.srb.SRBFileOutputStream;
import edu.sdsc.grid.io.srb.SRBException;
import edu.sdsc.grid.io.local.LocalFile;
import edu.sdsc.grid.io.srb.SRBRandomAccessFile;
import edu.sdsc.grid.io.srb.SRBAccount;

import org.apache.lucene.store.SRBDirectory;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.FSDirectory;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.index.FilterIndexReader;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.queryParser.QueryParser;
import org.apache.lucene.search.Hits;
import org.apache.lucene.search.IndexSearcher;
//import org.apache.lucene.search.Query;
import org.apache.lucene.search.Searcher;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Date;
import java.util.StringTokenizer;
import java.io.*;
import java.net.*;
import java.lang.Thread.*;

import queryjob.ws.QueryService;
import queryjob.ws.QueryServiceLocator;
import queryjob.ws.Query;



public class queryjob{

    private static SRBFileSystem srbFileSystem = null;
    private static SRBFile srbDir = null;
    private static String indexdirname ;
    static SRBFile srbindexfile;
    static String aquery;
    private static  int queryPort = 9095;
    private static ServerSocket server;
    private static Socket client;


    public static void main(String[] args)throws Exception{
        String field = "contents";
        /*System.out.println("\nQuery to handle\n"+ args[0]);
        aquery = args[0];
        int QueryID = Integer.parseInt(args[1]);
        int numqueryservers = Integer.parseInt(args[2]);
        int port = Integer.parseInt(args[3]);*/

        //open index on this server and perform searches on server
        //later will need to return results to scheduler for merging
        LocalFile Env = new LocalFile(".MdasEnv");
        LocalFile Auth = new LocalFile(".MdasAuth"); 
        srbFileSystem = new SRBHandler(Env, Auth).getSRBFileSystem();

        String localvault = new StringTokenizer(java.net.InetAddress.getLocalHost().getHostName(),".").nextToken();
        indexdirname = "_index_"+localvault;
        //get index off SRB space
        SRBFile indexonsrb = new SRBFile(srbFileSystem,  indexdirname);
        LocalFile indexlocal = new LocalFile(indexdirname);
        System.out.println("This is node: "+ indexdirname);
        indexonsrb.copyTo(indexlocal);

        //String name = "/home/ndapa/apps/GriSAD/queryjob/"+indexdirname;
        //PrintWriter out2 = new PrintWriter(new BufferedWriter(new FileWriter(name, false)));
 
        server = new ServerSocket(queryPort,1000);
        BufferedReader in;
        StringTokenizer st;
        String line;
        int numqueryservers;

        // Web Services : Make a service
        QueryService service = new QueryServiceLocator();
        // Now use the service to get a stub to the service
        Query queryservice  = service.getquery();

        Directory indexdir = FSDirectory.getDirectory(indexlocal.getFile());
        //SRBDirectory indexdir = new SRBDirectory(indexfile);
        final IndexReader reader = IndexReader.open(indexdir);
        final Searcher searcher = new IndexSearcher(reader);
        final Analyzer analyzer = new StandardAnalyzer();
        final QueryParser parser = new QueryParser(field, analyzer);


        while(true){
            client  = server.accept(); //wait for results
            //need to start thread here to handle query
            // if threads are more than a certain number we wait.

//             Thread handleq = new Thread (new Runnable() {
//             public void run() {
//                 int g = 0;
//             }
//             });
//             handleq.start();

            in = new BufferedReader(new InputStreamReader(client.getInputStream()));
            line = in.readLine();
            st = new StringTokenizer(line,":"); //parse the query string, it comes along with QueryID, and port to results
            aquery = st.nextToken();
            final int QueryID = Integer.parseInt(st.nextToken());
            numqueryservers=Integer.parseInt(st.nextToken());
            final int port = Integer.parseInt(st.nextToken());

           Thread handleq = new Thread (new Runnable() {
               public void run() {
                    String response = "";
                    int ResultLength =0;
                    int repeat = 0;
                    boolean raw = false;
                    File indexfile;

	           try{
                        org.apache.lucene.search.Query query = parser.parse(aquery);
                        //System.out.println("Searching for: " + query.toString(field));

                        Hits hits = searcher.search(query);
                        System.out.println(hits.length() + " total matching documents");
                        if(hits.length() == 0){
                            response="null:0";
                        }
                        final int HITS_PER_PAGE = 10; int start =0;
                        ResultLength =hits.length();
                        int end = Math.min(hits.length(), start + HITS_PER_PAGE);
                        for (int i = start; i < end; i++) {
                            if (raw) {                              // output raw format
                            System.out.println("doc="+hits.id(i)+" score="+hits.score(i));
                            continue;
                            }
 
                            Document doc = hits.doc(i);
                            String path = doc.get("path");
                            if (path != null) {
                                    System.out.println((i+1) + ". " + path);
                            if(i==0)
                                    response+=path.replace(':',' ');
                            else
                                    response+=":"+path.replace(':',' ');

                            String title = doc.get("title");
                            if (title != null) {
                                    System.out.println("   Title: " + doc.get("title"));
                                title = title.replace(':', ' ');
                                if(title.length() > 60)
                                    title=title.substring(0,60)+ "...";
                                response+=" "+title+":"+hits.score(i);
                                    }
                            }else{
                                    System.out.println((i+1) + ". " + "No path for this document");
                            }
                        }
                        Socket socket = new Socket("sarabi.cs.uct.ac.za", port);
                        PrintWriter socketout = new PrintWriter(socket.getOutputStream(), true);
                        socketout.println(ResultLength+":"+QueryID+":"+response);
                        socketout.close();
                        //queryservice.mergeResults(QueryID, response,numqueryservers, port); //method merge results to return */
		}
		catch(Exception e){
                        try{
                        System.out.println("Error parsing query: "+aquery);
                        Socket socket = new Socket("sarabi.cs.uct.ac.za", port);
                        PrintWriter socketout = new PrintWriter(socket.getOutputStream(), true);
                        socketout.println("0:"+QueryID+":null:0");
                        socketout.close();}catch(Exception be){}
                    // queryservice.mergeResults(QueryID, "null",numqueryservers, port); //method merge results to return */
		}
              }
            });
            handleq.start();
        } //end of while
       

    }

    protected void finalize(){
       try{
            server.close();
            client.close();
        } catch (IOException e) {
            System.out.println("Could not close.");
            System.exit(-1);
        }
   }

} 


